use diesel::prelude::*;

#[derive(Queryable, Selectable)]
#[diesel(table_name = crate::schema::users)]
#[diesel(check_for_backend(diesel::sqlite::Sqlite))]
pub struct User {
    // pub id: Text,
    // pub username: sql_types::Text,
    // pub name: sql_types::Text,
    // pub password_digest: sql_types::Binary,
    pub id: Vec<u8>,
    pub username: String,
    pub name: Option<String>,
    pub password_digest: Vec<u8>,
}

#[derive(Insertable)]
#[diesel(table_name = crate::schema::users)]
pub struct NewUser<'a> {
    pub username: &'a str,
    pub name: Option<&'a str>,
    pub password_digest: &'a [u8],
}
