use std::env;

use crate::database;

#[derive(Clone)]
pub struct State {
    pub database: database::Database,
}

impl State {
    pub async fn new() -> Result<Self, anyhow::Error> {
        let database_url = env::var("DATABASE_URL").expect("DATABASE_URL must be set");
        let database = database::Database::new(database_url).await?;

        Ok(State { database })
    }
}
